#!/bin/sh
exec $ZEUSHOME/perl/miniperl -x $0 ${1+"$@"}
 if 0;
#!perl -w

# Send out the current list of backends to a particular loadbalancer

BEGIN { @INC=( "$ENV{ZEUSHOME}/perl/", "$ENV{ZEUSHOME}/webadmin/etc/" ); }
use ZeusOS;
use WebAdmin;

$_ = ( $ENV{QUERY_STRING} ) ? $ENV{QUERY_STRING} : "";
( $server ) = /server=(.*)/;
( $host, $port ) = split( ':', $server );
@backends = ();
$file = "$ENV{ZEUSHOME}/webadmin/conf/hosts";

if( open( HOSTS, "<$file" )) {
   while( <HOSTS> ) {
      chomp;
      push( @backends, $_ );
   }
   close( HOSTS );
} else {
   error_page( "Couldn't read the configuration file '$file': $!" );
}

$error = "";
$response = WebAdmin::command( $host, $port, "setbackends @backends\n",
                               $error );
if( $response ) {
   ( $response, $error ) = split( '\n', $response, 2 );
   if( $response eq "Success" ) { $error = 0 };
}
if( $error ) { error_page( "Failed to send list of backend webservers to " .
                           "'$server': $error" ) };

# Everything worked, so redirect now
print "Location: $ENV{HTTP_REFERER}\n\n";
exit;



# Something failed, so tell the user whats wrong
sub error_page( $ )
{
   $error = shift;

   print qq{ Content-Type: text/html

<html><head><title>Error!</title></head>
             <body bgcolor="#ffffff" text="#000000" link="#990066"
             vlink="#990066" alink="#990066">
             <h3>$error</h3></body></html>
           };
   exit;
}
