#!/bin/sh
exec $ZEUSHOME/perl/miniperl -x $0 ${1+"$@"}
 if 0;
#!perl -w

$request_method = $ENV{'REQUEST_METHOD'};

if ($request_method eq "GET") {
   $query_string = $ENV{'QUERY_STRING'};
} elsif ($request_method eq "POST") {
   $query_string = "";
   read STDIN, $query_string, $ENV{'CONTENT_LENGTH'};
}

foreach $key_value (split /&/, $query_string) {
   ($key, $value) = split /=/, $key_value, 2;
   $value =~ tr/+/ /;
   $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C", hex($1))/eg;
   $form{$key} = $value;
}

print <<EOM;
Content-type: text/html

<body bgcolor=white>
EOM

if (!$form{'confroot'} || !$form{'vserver'}) {
   print "Please supply 'confroot' and 'vserver' values\n</body>\n"; exit 0;
}

# confroot is: <configdir>/https-<vservname>

$confroot = $form{'confroot'};
$vserver  = $form{'vserver'};

print "<h3>Creating NSAPI configuration for $vserver</h2>\n<blockquote>\n";

$confroot =~ s/\%zeushome\%/$ENV{'ZEUSHOME'}/e;

$confroot =~ m@(.*)/(.*)@;
($root, $vserv) = ($1, $2);

if ($vserv !~ /^https-/) {
   print "Error: invalid arguments\n</body>\n"; exit 1;
}

mymkdir ($root) if (! -d $root);
mymkdir ($confroot) if (! -d $confroot);

# Copy contents of ./skel to $confroot
mycpdir ("./skel", $confroot);

print "<p>\ndone.\n</blockquote>\n<p>\n";
print "<a href=\"$form{'redirect'}\">back to server configuration</a>\n";
print "</body>\n";

exit 0;

sub mymkdir {
   my ($dir) = @_;
   
   if (!mkdir $dir, 0755) {
      print "Error: could not create directory '$dir': $!\n</body>\n"; exit 1;
   } else {
      print "Created '$dir/'<br>\n";
   }
}

sub mycpdir {
   my ($srcd, $destd) = @_;
   my (@f); 
   
   opendir DIR, $srcd;
   @f = sort grep /^[^\.].*/, readdir DIR;
   closedir DIR;
   
   foreach $f (@f) {
      if (-d "$srcd/$f") {
         mymkdir ("$destd/$f") if (! -d "$destd/$f");
         mycpdir ("$srcd/$f", "$destd/$f");
      }
      if (-f "$srcd/$f") {
         mycpfile ("$srcd/$f", "$destd/$f") if (! -f "$destd/$f");
      }
   }
}

sub mycpfile {
   my ($srcf, $destf) = @_;
   
   if (!open IN, "<$srcf") {
      print "Error: could not read $srcf: $!\n</body>\n"; exit 1;
   }
   if (!open OUT, ">$destf") {
      print "Error: could not write $destf: $!\n</body>\n"; exit 1;
   }
   while (<IN>) { print OUT $_; }
   close IN; close OUT;
   
   print "Created '$destf'<br>\n";
}
